/*

Copyright (C) 2000, 2001 Christian Kreibich <cK@whoop.org>.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies of the Software and its documentation and acknowledgment shall be
given in the documentation and software packages that this Software was
used.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/
#ifndef efsd_options_h
#define efsd_options_h

#include <efsd.h>

/* Those fill in an existing EfsdOption struct ... */
EfsdOption  *efsd_option_new_get_stat(void);
EfsdOption  *efsd_option_new_get_lstat(void);
EfsdOption  *efsd_option_new_get_metadata(char *key, EfsdDatatype type);
EfsdOption  *efsd_option_new_get_filetype(void);
EfsdOption  *efsd_option_new_force(void);
EfsdOption  *efsd_option_new_recursive(void);
EfsdOption  *efsd_option_new_list_all(void);
EfsdOption  *efsd_option_new_sort(void);

/* ... and this one cleans up. The struct is NOT freed. */
void    efsd_option_cleanup(EfsdOption *eo);

#endif
